/*
#include "genesis.h"
#include "logo.h"
*/

#include "all.h"

int mycos_def[360]={
100,99,99,99,
99,99,99,99,
99,98,98,98,
97,97,97,96,
96,95,95,94,
93,93,92,92,
91,90,89,89,
88,87,86,85,
84,83,82,81,
80,79,78,77,
76,75,74,73,
71,70,69,68,
66,65,64,62,
61,60,58,57,
55,54,52,51,
50,48,46,45,
43,42,40,39,
37,35,34,32,
30,29,27,25,
24,22,20,19,
17,15,13,12,
10,8,6,5,
3,1,0,-1,
-3,-5,-6,-8,
-10,-12,-13,-15,
-17,-19,-20,-22,
-24,-25,-27,-29,
-30,-32,-34,-35,
-37,-39,-40,-42,
-43,-45,-46,-48,
-49,-51,-52,-54,
-55,-57,-58,-60,
-61,-62,-64,-65,
-66,-68,-69,-70,
-71,-73,-74,-75,
-76,-77,-78,-79,
-80,-81,-82,-83,
-84,-85,-86,-87,
-88,-89,-89,-90,
-91,-92,-92,-93,
-93,-94,-95,-95,
-96,-96,-97,-97,
-97,-98,-98,-98,
-99,-99,-99,-99,
-99,-99,-99,-99,
-100,-99,-99,-99,
-99,-99,-99,-99,
-99,-98,-98,-98,
-97,-97,-97,-96,
-96,-95,-95,-94,
-93,-93,-92,-92,
-91,-90,-89,-89,
-88,-87,-86,-85,
-84,-83,-82,-81,
-80,-79,-78,-77,
-76,-75,-74,-73,
-71,-70,-69,-68,
-66,-65,-64,-62,
-61,-60,-58,-57,
-55,-54,-52,-51,
-50,-48,-46,-45,
-43,-42,-40,-39,
-37,-35,-34,-32,
-30,-29,-27,-25,
-24,-22,-20,-19,
-17,-15,-13,-12,
-10,-8,-6,-5,
-3,-1,0,1,
3,5,6,8,
10,12,13,15,
17,19,20,22,
24,25,27,29,
30,32,34,35,
37,39,40,42,
43,45,46,48,
50,51,52,54,
55,57,58,60,
61,62,64,65,
66,68,69,70,
71,73,74,75,
76,77,78,79,
80,81,82,83,
84,85,86,87,
88,89,89,90,
91,92,92,93,
93,94,95,95,
96,96,97,97,
97,98,98,98,
99,99,99,99,
99,99,99,99,
};


uint pal_ico[16]={
0x000,
0xfff,
0xbbb,
0xddd,
0xfff,
0xfff,
0xfff,
0xeee,
0xccc,
0x666,
0x444,
0x111,
0x111,
0x000,
0x000,
0xfff,
};

uint index_table;

extern uchar KaneSnd[];
extern uchar KaneSndEnd[];


/***** Logo LinkSang sub-program ********/
/* Show the linksang logo		*/
/****************************************/
void Logo_LinkSang()
{
    register uint x, y;
    register uint Tile;
    
    Tile = 0;

/* Logo */
    dma_vram_copy(liksang0, 0, 32 * liksang0_HSize*liksang0_VSize);
    for (y=8; y< 21; y++)
    {
        for (x=9;x < 22; x++)
        {
        	show_tiles( Tile, Tile, 0, x, y, APLAN, 0, 0, 0);
        	Tile++;
       	}
    }

    wait_sync();    
    set_colors(0, pal_liksang); 

/* URL */
    dma_vram_copy(tiledata, 32 * liksang0_HSize*liksang0_VSize, 32*96);
    set_colors(1, pal_ico); 

    index_table = 0;
    
    /* Wavy some secs :) */
    for (x = 0; x < 150; x++)
    	WaveText("WWW.LIK-SANG.COM", 1, liksang0_HSize*liksang0_VSize);    	  
    
    fade(pal_liksang, pal_black, 0, 0);
    WaveText("                ", 1, liksang0_HSize*liksang0_VSize);    	      
    RAZ();
}


/* Print a text using palette pal and with charset def starting at tile TileDef */
/* with Wave effect!!! 								*/
void WaveText(text, pal, TileDef)
uchar *text;
uint pal;
uint TileDef;
{
	register uint len, i;
	uint tmp_index; /* index in the pre-defined cosinus array */
	uint origy;
	int diffy;
	uint y;
	
	origy=22*8;
	diffy=10;
	
    	len = strlen(text);

    	/* We make a (-32) because the first 32 chars are not defined on the charset, since they are control chars */        	
    	for (i=0;i < len;i++)
    	{
    		tmp_index = index_table + 10*i;
    		if (tmp_index >= 360) tmp_index = tmp_index -360;
    		    		
    		y = origy +  ((diffy * mycos_def[tmp_index])/100);
    		
    		def_sprite(i+1,7*8+i*8,y,0x000, 0x6000 + (TileDef + text[i] - 32) );
    	}

	
	index_table +=len;
	if (index_table >= 360)  index_table=0;
	
	show_sprite(1, len);
	Wait(2);	
}



/******* Logo y2kode sub-program ********/
/* Show the y2kode logo			*/
/****************************************/
void Logo_y2kode()
{

    register uint x, y;
    register uint Tile;
    
    Tile = 0;

    /* show the y2kode logo */
    dma_vram_copy(y2k0, 0, 32 * y2k0_HSize*y2k0_VSize);
    for (y=4; y< 24; y++)
    {
        for (x=0;x < 32; x++)
        {
        	show_tiles( Tile, Tile, 0, x, y, APLAN, 0, 0, 0);
        	Tile++;
       	}
    }

    wait_sync();    
    fade(pal_black, pal_y2k, 0, 2);

    /* nothing to do so....60fps...for 3s, wait 180*/
    Wait(180);
}



/****** MyLogo sub-program ******/
/* Show my own logo :)		*/
/********************************/
void MyLogo()
{
    register int x, y;
    register uint Tile;
    uint joy;
    uchar Trick;

    Tile = 0;


    /* if buttonA is pressed, i show my hidden logo else normal logo*/
    init_joypad();
    joy= read_joypad1();

    if (joy)
    {
        	switch(joy & 0xff)
        	{
        		case BUTTON_A:
        			dma_vram_copy(kancell0, 0, 32 * kancell0_HSize*kancell0_VSize);
				for (y=0; y< kancell0_VSize; y++)
				{
        				for (x=0;x < kancell0_HSize; x++)
        				{
        					show_tiles( Tile, Tile, 0, x, y, BPLAN, 0, 0, 0);
        					Tile++;
       					}
    				}
    				Trick = 1;
				break;
     			default:
				dma_vram_copy(defaultTile, 0, 32);
        			Tile = kancell0_HSize*kancell0_VSize;
        			Trick = 0;     				
		}
    }
            
    
    /* drawing the big KANEDA */
    dma_vram_copy(kaneda0, 32 * kancell0_HSize*kancell0_VSize, 32 * kaneda0_HSize*kaneda0_VSize);

    for (y=0; y< kaneda0_VSize; y++)
    {
        for (x=0;x < kaneda0_HSize; x++)
        {
        	show_tiles( Tile, Tile, 1, x, y, APLAN, 0, 0, 0);
        	Tile++;
       	}
    }

   Tile--; 
    for (y=kaneda0_VSize; y< 32; y++)
    {
        for (x=0;x < 32; x++)
        {
        	show_tiles( Tile, Tile, 1, x, y, APLAN, 0, 0, 0);
        }
    }


    wait_sync();    
    set_colors(1, pal_kaneda); 
    fade(pal_black, pal_kancell, 0, 4);
    
    /* hehe! even a sound if you find the cheat */
    if (Trick)	play_sample(KaneSnd, KaneSndEnd-KaneSnd);

    
    /* nice down & up scroll */
    for (x=0; x > -160; x--) /* down */
    {
    	scrollv(x, 0); /* only PlanA scroll */
    	wait_sync(); /* needed! */
    }

    for (; x < (Trick*24 -64) ; x++) /* up */
    {
    	scrollv(x, 0);
    	wait_sync();
    }
    	
    	
    Wait(180);
    RAZ();
}



/******* TransHour ******/
/* Watch type transition*/
/* I need to know which	*/
/* plan and which tile  */
/* i can use. I use pal3*/
/************************/
void TransHour( Plan, TileIndex )
uint Plan;
uint TileIndex;
{
	register uint x, y;
	
	dma_vram_copy(&Trans0[0], TileIndex, 32);	
	wait_sync();
	
    	for (y=0; y< 28; y++)
    	{
        	for (x=0;x < 32; x++)
        	{
        		show_tiles(TileIndex/32 , TileIndex/32, 3, x, y, Plan, 1, 0, 0);        	
       		}
    	}
	/* pal black is defined in Genesis.o */
	set_colors(3,pal_black);
		
	for (y=1; y< 49; y++)
	{
		Wait(1);
		dma_vram_copy(&Trans0[y*8], TileIndex, 32);	
	}
	RAZ();
}


/* A nice fade effect */
/* if Flag > 0 then we'll wait Flag ticks between each palette update */
/* else we'll do a special thing (here Wave) */
void fade(palSrc, palDest, palNum, Flag)
uint *palSrc;
uint *palDest;
uint palNum;
uchar Flag;
{
    uint tmp_pal[16];
    char signe[16];
    register ulong *pl;
    register uint *pw;
    register uint i, j;
    register ulong Decal;

    /* see set_colors() */
    Decal = (32 * palNum);

    /* Initialize a temporary palette */
    for (i = 0; i < 16; i++)
    {
        tmp_pal[i] = palSrc[i];
        if (palSrc[i]>palDest[i])
        	signe[i]=-1;
        else
        	signe[i]=1;
    }

    /* Fade in loop */
    for (i = 0; i < 16; i++)
    {
        /* Setup GFX to save colors */
        pl = (ulong *) GFXCNTL;
        *pl = GFX_COLOR_WRITE_ADDR(Decal);

        /* Setup GFX data register */
        pw = (uint *) GFXDATA;
        
        /* Increment one color B,G,R at a time */
        for (j = 0; j < 16; j++)
        {
            /* increment BLUE till reaching target color */
            if ( (tmp_pal[j] & 0xf00) != (palDest[j] & 0xf00) ) tmp_pal[j] += signe[j]*0x100;
            /* check GREEN */
            if ( (tmp_pal[j] & 0xf0) != (palDest[j] & 0xf0) )	tmp_pal[j] += signe[j]*0x10;
            /* check RED */
            if ( (tmp_pal[j] & 0xf) != (palDest[j] & 0xf) )	tmp_pal[j] += signe[j]*0x1;

            /* Store color */
            *pw = tmp_pal[j];
        }

        /* Wait a sec... */        
        if (Flag)	
        	Wait(Flag);
        else
        	WaveText("WWW.LIK-SANG.COM", 1, liksang0_HSize*liksang0_VSize);                 
    }
}
